---
title: XRPermissionDescriptor.optionalFeatures
slug: Web/API/XRPermissionDescriptor/optionalFeatures
tags:
  - API
  - AR
  - Mixed
  - Permissions
  - Property
  - Reality
  - Reference
  - Reference Space
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRPermissionDescriptor
  - augmented
  - descriptor
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p><span class="seoSummary">The {{domxref("XRPermissionDescriptor")}} dictionary's <code><strong>optionalFeatures</strong></code> property is used to specify a list of WebXR features which your app or site would like to use but can operate without if permission isn't granted to use them.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrPermissionDescriptor</em> = {
   mode: <em>xrSessionMode</em>,
   requiredFeatures: <em>reqFeatureList</em>,
   optionalFeatures: <em>optFeatureList
</em>};

<em>xrPermissionDescriptor</em>.optionalFeatures = <em>optFeatureList</em>;
<em>optFeatureList</em> = <em>xrPermissionDescriptor</em>.optionalFeatures;</pre>

<h3 id="Value">Value</h3>

<p>An array of strings taken from the {{domxref("XRReferenceSpaceType")}} enumerated type, indicating set of features that your app would like to use, but can operate without if permission to use them isn't available. While further features may be defined in future editions of WebXR, currently all permitted values come from the {{domxref("XRReferenceSpaceType")}} enumerated type, indicating reference spaces the app rquires to be available.</p>

<p>{{page("/en-US/docs/Web/API/XRReferenceSpaceType", "Values")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">let xrPermissionDesc = {
  name: "xr",
  mode: "immersive-vr",
  optionalFeatures: [ "bounded-floor" ]
};

if (navigator.permissions) {
  navigator.permissions.query(xrPermissionDesc).then(({state}) =&gt; {
    switch(state) {
      case "granted":
        setupXR();
        break;
      case "prompt":
        promptAndSetupXR();
        break;
      default:
        /* do nothing otherwise */
       break;
  }
  .catch(err) {
    console.log(err);
  }
} else {
  setupXR();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrpermissiondescriptor-optionalfeatures','XRPermissionDescriptor.optionalFeatures')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRPermissionDescriptor.optionalFeatures")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Permissions_and_security">Permissions and security for WebXR</a></li>
 <li>{{domxref("XRPermissionStatus")}}</li>
 <li>{{domxref("navigator.permissions")}} and {{domxref("WorkerNavigator.permissions")}}</li>
 <li>{{domxref("Permissions")}}</li>
</ul>
